# -*- coding:Utf-8 -*-
import es, psyco, playerviewlib
from playerviewlib import PlayerViewLibError
psyco.full()

# create server command "playerview"
if not es.exists("command", "playerview"):
    es.regcmd("playerview", "playerview/command", "playerview: Allow you to know what entity a player is aiming")

def command():
    # check count of argument
    argcount = es.getargc()
    if argcount < 2: _global_syntax()
    elif argcount < 3:
        function = es.getargv(1)
        if function in playerviewlib._functions: _function_syntax(function)
        else: _global_syntax()

    else:
        # get function, userid and block to execute
        function, userid, block, parameter = es.getargv(1), es.getargv(2), es.getargv(3), es.getargv(4)
        # check if block is executable
        if not es.exists("block", block): raise PlayerViewLibError("block error", block)

        parameter = parameter if parameter <> "0" else ""
        playerview = playerviewlib.PlayerView(userid)
        playerview.block = block

        # get index of entity
        if function == "entity": playerview.entity(parameter)
        # get userid of player
        elif function == "player": playerview.player(parameter)
        # get index of weapon
        elif function == "weapon": playerview.weapon(parameter)
        # get coordinates where the player is aiming
        elif function == "coord": playerview.coord()

def _global_syntax():
    es.dbgmsg(
        0,
        "\n" + playerviewlib._language("playerview syntax") + "\n\n" +
        playerviewlib._language("playerview function") + "\n" +
        playerviewlib._language("entity function") + "\n" +
        playerviewlib._language("player function") + "\n" +
        playerviewlib._language("weapon function") + "\n" +
        playerviewlib._language("coord function") + "\n")

def _function_syntax(function):
    string = "\n" + playerviewlib._language(function + " syntax") + "\n"
    if function <> "coord":
        string += "\n" + playerviewlib._language("playerview parameter", function) + "\n"
        string += playerviewlib._language(function + " parameter") + "\n"
    es.dbgmsg(0, string)
